//
// GRAPHIO.CPP
//
// Modulo principale di CURVES 1.0
//
// Amato Gianluca, De Fanis Alberto, Paolini Emanuele
//

#include <conio.h>
#include <ctype.h>
#include <graphics.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <strstrea.h>
#include <fstream.h>
#include <new.h>
#include <dos.h>

#include "vector.h"
#include "parser.h"
#include "integr.h"
#include "mouse.h"
#include "keys.h"

//*** Variabili  pubbliche

int maxx2,maxy2;     	       	 // getmaxx()/2 e getmaxy()/2
double mgx, mgy;     		     // numero di pixel per cm.
int page=0;                      // pagina attuale
char self=0;                     // movimento automatico
char redraw=1;			         // 1 se devo ridisegnare l'immagine
char dualpage=0;		     	 // 1 se si usa la doppia pagina

//*** Variabili locali

enum mode {NORMAL, STEREO};      // modi visualizzazione
static mode draw_mode;

static int gdriver, gmode;       // modo video corrente
static double mgn=2;             // ingrandimento attuale
static char menumode=1; 	  	 // 1 c' la barra del men

static char DATAINV[] = "dato numerico invalido";
static char EXITERR[] = "errore registrazione procedure di uscita";

//*** Gestione delle finestre

// viewport di uso generale

void totalview()
{
	setviewport(0,0,maxx2*2,maxy2*2,1);
}

void menuview()
{
	setviewport(0,maxy2*2-8*4,maxx2*2,maxy2*2,1);
}

void drawview()
{
	setviewport(0,0,maxx2*2,maxy2*2-8*4-1,1);
}

// visualizza men

void menu()
{
	int i=page;

	menuview();
	setcolor (KEYCOLOR);
	do {
		setactivepage(i);
		if (i==page) mouse_off();
		asm cli
		clearviewport();
		line(0,0,maxx2*2,0);
		asm sti
		if (i==page) mouse_on();
	} while (dualpage && (i=1-i) != page);
}

// clearviewpiort velocizzata in assembler

void myclearviewport()
{
	if (gdriver==VGA || gdriver>=2  && gdriver<=5) {
		asm {
			mov ax,0xA000
			mov es,ax
			xor ax,ax
			mov di,0
			mov cx,0x3160
			cmp page,0
			je scrivi
			add di,0x8000
		}
	scrivi:
		asm rep stosw
	} else if (gdriver==CGA) asm {
			mov ax,0xB800
			mov es,ax
			xor ax,ax
			mov di,0
			mov cx,3320
			rep stosw
			add di,1501
			mov cx,3360
			rep stosw
	}
}

// legge palette del DAC

void getrgbpalette (int colornum, int *red, int *green, int *blue)
{
	_AX=0x1015; _BL=(unsigned char)colornum;
	asm int 0x10
	*red=_DH; *green=_CH; *blue=_CL;
}

//*** Gestione errori

void fatalerror (char *st)
{
	restorecrtmode();
	cout << "Errore fatale: " << st;
	exit (1);
}

// routine gestione mancanza di memoria

void mynewhandler ()
{
	fatalerror (NOMEM);
}

// routine di uscita

void exitfunc()
{
	mouse_reset();
	closegraph();
}

// routine Ctrl-C

#pragma warn -rvl
int mybreak()
{
	exit(3);
}
#pragma warn +rvl

// visualizza errore

void showerror(char *error)
{
	Key err(error,ENTER,KCENTER,maxx2,13);

	menu();
	err.on();
	cout << '\07';
	while (mygetch()!=ENTER);
	err.off();
}

// visualizza errori nelle stringhe di equazione evidenziandone
// la posizione

void showposerror(char *error, char *str, int poserr)
{
	char temp[80], *p;

	strcpy (temp,error); strcat (temp," : ");
	strcat (temp,str); strcat(temp," ");
	if (poserr>-1) {
		strins (p=temp+strlen(error)+2+poserr,'~');
		strins (p+2,'~');
	}
	showerror (temp);
}

//*** Inizializzazione

// setta parametri hardware

void setup()
{
	int x,y;
	getaspectratio(&x,&y);
	mgx=(maxx2*2)/screenl;
	mgy=mgx*x/y;
}

void ioinitialize()
{
	int er;

	ctrlbrk (mybreak);
	detectgraph (&gdriver,&gmode);

	if (gdriver==VGA) gmode=VGAMED;
	if (gdriver==VGA || gdriver==EGA || gdriver==EGAMONO
		|| gdriver==HERCMONO) dualpage=self=1;
	initgraph (&gdriver,&gmode,NULL);
	if (er=graphresult())
		fatalerror (grapherrormsg(er));
	if (atexit (exitfunc))
		fatalerror (EXITERR);

	maxx2=getmaxx()/2;
	maxy2=getmaxy()/2;

	setup();

	mouse_reset();
	mouse_rangex(0,maxx2*2);
	mouse_rangey(0,maxy2*2);
	mouse_on();

	set_new_handler(mynewhandler);

  // Dichiarazione dei pulsanti

	(new Trimmer("x rot.",TRIMMER1,0,2,98,30))->val=0.2;
	(new Trimmer("y rot.",TRIMMER2,100,2,98,30))->val=-0.1;
	new Trimmer("trasl.",TRIMMERZ,200,2,98,30);

	new Key("~A~UTO",'a',0,300,2);
	new Key("+",'+',0,300,20);
	new Key("-",'-',0,324,20);
	new Key("<--",LEFT,KREPEAT,386,20);
	new Key("-->",RIGHT,KREPEAT,425,20);
	new Key("  ",UP,KREPEAT,346,2);
	new Key("  ",DOWN,KREPEAT,346,20);
	new Key("allontana",PGUP,KREPEAT,485,2);
	new Key("avvicina ",PGDOWN,KREPEAT,485,16);
	new Key("~M~ODE",'m',0,580,16);
	new Key("~p~ag",'p',0,428,2);

	new Key("ESCI",ESC,0,580,2);

	new Key(" ~S~I ",'s',0,580,2);
	new Key(" ~N~O ",'n',0,580,16);

	new Key("~s~inistra",ALIAS(1,'s'),0,300,2);
	new Key(" ~d~estra ",'d',0,380,2);
	new Key(" ~c~entro ",'c',KXCENTER,377,16);
	new Trimmer(" RED ",TRIMMERR,0,2,98,30);
	new Trimmer("GREEN",TRIMMERG,100,2,98,30);
	new Trimmer(" BLUE",TRIMMERB,200,2,98,30);

	new Key("~V~isualizzazione",'v',0,300,2);
	new Key("~E~quazione",'e',0,150,2);
	new Key("~O~pzioni",'o',0,10,2);
	new Key("~C~olori",ALIAS (1,'c'),0,470,2);

	new Key("Azzera",CTRLBACKSPACE,0,580,16);
	new Key(" ~O~K ",ALIAS(2,'o'),0,510,2);


	(exprk=new Expression ("0"))->compile();
	(exprt=new Expression ("0"))->compile();
}

//*** Ridisegna la curva

void draw()
{
	if (redraw) {
		page=dualpage ? 1-page : page;
		if (!dualpage) mouse_off();
		setactivepage(page);
		if (menumode) {
			drawview();
			myclearviewport();
		} else {
			totalview();
			cleardevice();
		}
		switch(draw_mode) {
			case NORMAL: normal_draw(); break;
			case STEREO: stereo_draw(); break;
		}
		if (dualpage) {
			setvisualpage(page);
			mouse_off();
			setdisplaypage(page);
		}
		mouse_on();
		redraw=0;
	}
}


//*** Men di visualizzazione

void movement()
{
	static int MOVKEYS1[]={TRIMMER1,TRIMMER2,TRIMMERZ,'p','a','+','-',PGUP,
						   PGDOWN,'m',ESC,0};
	static int MOVKEYS2[]={LEFT,RIGHT,UP,DOWN,0};
	vector3d ztr(0,0,1),xtr(1,0,0),ytr(0,1,0);
	int ch;

	keyon(MOVKEYS1);
	if (!self)
		keyon(MOVKEYS2);
	do {
		redraw=1;
		if ((ch=mygetch()) <= 0xff) ch=tolower(ch);
		switch(ch) {
			case NOKEY:
			case ' ':
			case 'p':
				if (menumode){
					if (ch=='p') {
						menumode=0;
						keyoff(NULL,0);
					}
				} else {
					menumode=1; menu();
					keyon(MOVKEYS1);
					if (!self) keyon(MOVKEYS2);
					redraw=0;
				}
				break;
			case RIGHT :rotate (1,-fabs(ALPHA1)); break;
			case LEFT  :rotate (1,fabs(ALPHA1)); break;
			case UP    :rotate (0,fabs(ALPHA2)); break;
			case DOWN  :rotate (0,-fabs(ALPHA2)); break;
			case PGUP  :
				if (TRASL!=0)
					traslate(ztr*fabs(TRASL));
				else
					traslate(ztr);
				break;
			case PGDOWN:
				if (TRASL!=0)
					traslate(-ztr*fabs(TRASL));
				else
					traslate(-ztr);
				break;
			case '+':magnify(mgn);break;
			case '-':magnify(1/mgn);break;
			case 'm':draw_mode=(draw_mode==NORMAL)?STEREO:NORMAL;break;
			case 'a':
				self=!self;
				if (self)
					keyoff(MOVKEYS2);
				else
					keyon(MOVKEYS2);
				break;
			case '8':traslate(ytr);break;
			case '2':traslate(-ytr);break;
			case '4':traslate(-xtr);break;
			case '6':traslate(xtr);break;
			case '5':initpos();break;
			default: redraw=0; break;
		}
	} while (ch!=ESC);
	if(menumode)
		keyoff();
	else
		menu();
	menumode=1;
}

//*** Men di immissione equazioni

Expression *setequation (char *str)
{
	Expression *exp=new Expression(str,&mys);
	char *error;
	int poserr;

	exp->compile();
	if ( poserr=parsererror(&error) ) {
		showposerror (error,str,poserr);
		return NULL;
	}
	return exp;
}

// Gestisce inserimento stringhe da tastiera

static int EQUKEYS[]={ESC,'k','t',ALIAS(1,'d'),ALIAS(1,'a'),ALIAS(1,'n'),
					  ALIAS(1,'i'),0};

inline ios& rewind (ios &s)
{
	s.rdbuf()->seekpos(0);
	return s;
}

void getequations()
{
	static InputKey kkey("~k~(s)",'k',35,1,2);
	static InputKey tkey("~t~(s)",'t',35,1,18);
	static InputKey dakey("~d~a",ALIAS(1,'d'),9,350,2);
	static InputKey akey(" ~a~",ALIAS(1,'a'),9,350,18);
	static InputKey nkey("~N~P",ALIAS(1,'n'),5,480,3);
	static InputKey ikey(" ~I~",ALIAS(1,'i'),3,480,18);

	static double da=0,a=10;
	static unsigned int n=200, i=1;

	strstream out;
	char *p;
	int ch;
	static int modified=1;

	do {
		do {
			if (exprk) {
				out << rewind << *exprk << endl;
				out.getline (kkey.val,35);
			}
			if (exprt) {
				out << rewind << *exprt << endl;
				out.getline (tkey.val,35);
			}
			out << rewind << da << endl;
			out.getline (dakey.val,9);
			out << rewind << a << endl;
			out.getline (akey.val,9);
			out << rewind << n << endl;
			out.getline (nkey.val,5);
			out << rewind << i << endl;
			out.getline (ikey.val,3);
			keyon (EQUKEYS);
			switch(ch=tolower(mygetch())) {
				case 'k':
					if (exprk) delete exprk;
					if (!(exprk=setequation(kkey.val))) ungetch('k');
					modified=1;
					break;
				case 't':
					if (exprt) delete exprt;
					if (!(exprt=setequation(tkey.val))) ungetch ('t');
					modified=1;
					break;
				case 'd':
					da=strtod(dakey.val,&p);
					if (*p) { showerror (DATAINV); ungetch ('d'); }
					modified=1;
					break;
				case 'a':
					a=strtod(akey.val,&p);
					if (*p) { showerror (DATAINV); ungetch('a'); }
					modified=1;
					break;
				case 'n':
					n=(unsigned int)strtoul(nkey.val,&p,10);
					if (*p) { showerror (DATAINV); ungetch ('n'); }
					modified=1;
					break;
				case 'i':
					i=(unsigned int)strtoul(ikey.val,&p,10);
					if (*p) { showerror (DATAINV); ungetch ('i'); }
					modified=1;
					break;
			}
		} while (ch!=ESC);
		keyoff (EQUKEYS,0);
		menu();
		p=NULL;
		if (modified)
		{
			int KEYRISP[]={'s','n',0};
			write(10,10,"Integro la nuova curva?");
			keyon(KEYRISP);
			do {
				ch=tolower(mygetch());
			} while(ch!='s' && ch!='n');
			keyoff(KEYRISP,0);
			menu();
			if (ch=='s') {
				p=integrate (da,a,n,i);
				initpos();
				redraw=1;
				if (p)
					showerror (p);
				else
					modified=0;
			}
		}
	} while (p);
}

//*** Men delle opzioni di visualizzazione

void saveoptions()
{
	int r,g,b;

	fstream fout("curves.cfg",ios::out);
	fout << screenl << ' ' << kprosp << ' ' << eyedist2*2 << ' ';
	getrgbpalette(EGA_WHITE,&r,&g,&b);
	fout << r << ' ' << g << ' ' << b << ' ';
	getrgbpalette(EGA_RED,&r,&g,&b);
	fout << r << ' ' << g << ' ' << b << ' ';
	getrgbpalette(EGA_BLUE,&r,&g,&b);
	fout << r << ' ' << g << ' ' << b << ' ';
}

void loadoptions()
{
	int r,g,b;

	fstream fin("curves.cfg",ios::in);
	if (fin.good()) {
		fin >> screenl >> kprosp >> eyedist2;
		eyedist2/=2;
		fin >> r >> g >> b;
		setrgbpalette(EGA_WHITE,r,g,b);
		fin >> r >> g >> b;
		setrgbpalette(EGA_RED,r,g,b);
		fin >> r >> g >> b;
		setrgbpalette(EGA_BLUE,r,g,b);
	}
}

//*** Men opzioni varie

void options2()
{
	static InputKey
		lkey("~L~arghezza monitor (cm.)     :",'l',5,1,2),
		dkey("~D~istanza monitor P.V. (cm.) :",ALIAS (2,'d'),5,1,18),
		okey("Distanza tra ~O~cchi(cm.) :",ALIAS (1,'o'),5,300,18);
	static Key
		skey("~S~ALVA",ALIAS (2,'s'),0,300,2);
	static int OPTKEYS[]={ESC,'l',ALIAS (2,'d'),ALIAS(1,'o'),ALIAS(2,'s'),0};

	strstream out;
	int ch;
	char *p;

	do{
		out.rdbuf()->seekpos(0);
		out<<screenl<<endl;
		out.getline(lkey.val,5);
		out<<kprosp<<endl;
		out.getline(dkey.val,5);
		out<<eyedist2*2<<endl;
		out.getline(okey.val,5);
		keyon(OPTKEYS);
		switch(ch=mygetch())
		{
			case 'l':
				screenl=strtod(lkey.val,&p);
				if(*p) { showerror(DATAINV);ungetch('l');}
				setup();
				break;
			case 'd':
				kprosp=strtod(dkey.val,&p);
				if (*p) { showerror(DATAINV);ungetch('d');}
				break;
			case 'o':
				eyedist2=strtod(okey.val,&p)/2;
				if (*p) { showerror(DATAINV);ungetch('o');}
				break;
			case 's':
				saveoptions();
				keyoff (NULL,0);
				showerror("Opzioni salvate su disco.");
				break;
		}

	} while(ch!=ESC);
	keyoff(NULL,0);
	menu();
}

//*** Men del settaggio dei colori

void options()
{
	static int COLORKEYS[]={ESC, TRIMMERR, TRIMMERB, TRIMMERG, ALIAS(1,'s'), 'd', 'c',0};
	static int TRIM[]={TRIMMERR, TRIMMERB, TRIMMERG, 0};
	static int currcol=EGA_WHITE, settrimmer=1;
	int ch, r, g, b, r1, g1, b1;

	if (gdriver!=VGA) {
		showerror (" necessaria una VGA per modificare i colori");
		return;
	}
	keyon (COLORKEYS);
	do {
		if (settrimmer) {
			getrgbpalette (currcol,&r,&g,&b);
			PALETTE(TRIMMERR)=r/31.5-1;
			PALETTE(TRIMMERB)=b/31.5-1;
			PALETTE(TRIMMERG)=g/31.5-1;
			settrimmer=0; keyon(TRIM);
		}
		switch (ch=mygetch()) {
			case 's': currcol=EGA_RED; settrimmer=1; break;
			case 'd': currcol=EGA_BLUE; settrimmer=1; break;
			case 'c': currcol=EGA_WHITE; settrimmer=1; break;
			case TRIMMERR:
			case TRIMMERB:
			case TRIMMERG:
				setrgbpalette(currcol,(PALETTE(TRIMMERR)+1)*31.5,
					(PALETTE(TRIMMERG)+1)*31.5,(PALETTE(TRIMMERB)+1)*31.5);
				if (currcol!=EGA_WHITE) {
					getrgbpalette (EGA_RED,&r,&g,&b);
					getrgbpalette (EGA_BLUE,&r1,&g1,&b1);
					setrgbpalette (EGA_RED | EGA_BLUE,(r+r1)/2,(g+g1)/2,(b+b1)/2);
				}
		}
	} while (ch!=ESC);
	keyoff (COLORKEYS);
}

//*** Men principale

void mainmenu()
{
	int ch;
	static int MAINKEYS[]={'v','e','o',ALIAS(1,'c'),27,0};

	menu();
	keyon(MAINKEYS);
	redraw=1;
	do {
		switch(ch=mygetch()) {
			case 'v':keyoff(); movement(); keyon(MAINKEYS); break;
			case 'e':keyoff(); getequations(); keyon(MAINKEYS); break;
			case 'c':keyoff(); options(); keyon(MAINKEYS); break;
			case 'o':keyoff(); options2();keyon(MAINKEYS); break;
		}
	} while (ch!=ESC);
	keyoff(NULL,0);
}

//*** Pagina iniziale

void intro()
{
	static int INTROKEYS[]={ALIAS(2,'o'),0};
	menu();
	keyon(INTROKEYS);
	write(150,5,"3 D  -  C U R V E S   1.0");
	write(50,18,"Amato Gianluca, De Fanis Alberto, Paolini Emanuele");
	mygetch();
	keyoff();
}

void main()
{
	ioinitialize();
	loadoptions();
	initpos();
	intro();
	mainmenu();
}