#include <stdio.h>

#define KREPEAT 1
#define KXCENTER 2
#define KYCENTER 4
#define KCENTER KYCENTER | KXCENTER
#define KDELETE 8

#define KEYCOLOR WHITE

#define SPECIAL 256          // usato per tasti con codice esteso
#define NOKEY 512            // usato per trimmer o pressioni fuori zona
#define MASKBIT 0x3FF        // maschera i bit identificativi

// caratteri speciali

#define UP (SPECIAL+'H')
#define DOWN (SPECIAL+'P')
#define RIGHT (SPECIAL+'M')
#define LEFT (SPECIAL+'K')
#define PGUP (SPECIAL+'I')
#define PGDOWN (SPECIAL+'Q')
#define INS (SPECIAL+'R')
#define DEL (SPECIAL+'S')
#define ESC (27)
#define SPACE (32)
#define BACKSPACE (8)
#define CTRLBACKSPACE (127)
#define ENTER (13)

#define TRIMMER1 NOKEY+1
#define TRIMMER2 NOKEY+2
#define TRIMMERZ NOKEY+3
#define TRIMMERR NOKEY+4
#define TRIMMERG NOKEY+5
#define TRIMMERB NOKEY+6

// macro

#define ALIAS(x,y) (x*1024+y)
#define ALPHA1 (((Trimmer *)(getkey(TRIMMER1)))->val*M_PI/12)
#define ALPHA2 (((Trimmer *)(getkey(TRIMMER2)))->val*M_PI/12)
#define TRASL  (((Trimmer *)(getkey(TRIMMERZ)))->val*4)
#define PALETTE(x) (((Trimmer *)getkey(x))->val)


extern int mygetch();
extern void strins(char *s,char c);
extern void write(int,int,char *,int del=0);
class Key
{
	protected:
		static Key *first;
		Key* next;
		int x,y;
		int xx,yy;
		char *name;
		char ison;            // 1 il tasto  attivo
		int key;
		char repeat;          // si pu tenere schiacciato
	public:
		Key(char *s, int k, char type, int kx,int ky,int w=0,int h=0);
		virtual ~Key();
		virtual void on();
		virtual void off();
		virtual int touch(int kx=-1,int ky=0,int c=NOKEY);
		friend int getkeyxy(int ,int x=0, int y=0);
		friend void keyon(int *s=NULL, int draw=1);
		friend void keyoff(int *s=NULL, int draw=1);
		friend Key* getkey(int);
};

class InputKey: public Key
{
	public:
		char *val;
		int len;      //lunghezza massima stringa
		InputKey(char *s,int k,int l,int kx,int ky,int w=0,int h=0);
		~InputKey(){delete name;};
		virtual int touch(int kx=-1, int ky=0, int c=NOKEY);
		virtual void on();
		virtual void off();
};

class Trimmer: public Key
{
	public:
		double val;
		Trimmer(char *s,int k,int kx,int ky,int w=100,int h=23);
		virtual void on();
		virtual int touch(int kx=-1, int ky=0, int c=NOKEY);
	private:
		int h;
};
