//
// VECTOR.CPP
//
// Modulo per operazioni sui vettori di CURVES 1.0
//
// Amato Gianluca, De Fanis Alberto, Paolini Emanuele
//

#include <math.h>
#include <iostream.h>

#include "vector.h"

inline double sqr (double x) { return x*x; }

vector3d vector3d::operator - ()
{
  return vector3d(-x[0],-x[1],-x[2]);
}

vector3d vector3d::operator + (vector3d &dato)
{
	return vector3d(x[0]+dato.x[0],x[1]+dato.x[1],x[2]+dato.x[2]);
}

vector3d &vector3d::operator += (vector3d &dato)
{
	x[0]+=dato.x[0]; x[1]+=dato.x[1]; x[2]+=dato.x[2]; return *this;
}

vector3d vector3d::operator - (vector3d &dato)
{
	return vector3d(x[0]-dato.x[0],x[1]-dato.x[1],x[2]-dato.x[2]);
}

// prodotto vettoriale

vector3d vector3d::operator ^ (vector3d &dato)
{
	return vector3d(x[1]*dato.x[2]-x[2]*dato.x[1],-x[0]*dato.x[2]+
					x[2]*dato.x[0],x[0]*dato.x[1]-x[1]*dato.x[0]);
}

vector3d vector3d::operator * (double dato)
{
	return vector3d(x[0]*dato,x[1]*dato,x[2]*dato);
}

vector3d vector3d::operator / (double dato)
{
	return vector3d(x[0]/dato,x[1]/dato,x[2]/dato);
}

vector3d &vector3d::operator *= (double dato)
{
	x[0]*=dato; x[1]*=dato; x[2]*=dato;
	return *this;
}

vector3d &vector3d::operator /= (double dato)
{
	x[0]/=dato; x[1]/=dato; x[2]/=dato;
	return *this;
}

double abs (vector3d &dato) {
   return sqrt(sqr(dato.x[0])+sqr(dato.x[1])+sqr(dato.x[2]));
}

ostream & operator << (ostream &out, vector3d &dato)
{
  return out << '(' << dato.x[0] << ',' << dato.x[1] << ',' <<
			 dato.x[2] << ')';
}